import * as tslib_1 from "tslib";
import { isLoaderRequestElement } from "../../../types";
import { ModulePrefix } from "../../../";
import ResolveRoute from '../../../util/ResolveRoute';
var buildComputed = function (loaderRequest) {
    var computed = {};
    if (typeof loaderRequest === "string") {
        if (loaderRequest.trim() !== '') {
            computed[loaderRequest] = function () {
                return this.$store.state[ModulePrefix + "_post"].types.hasOwnProperty("pages") && this.$store.state[ModulePrefix + "_post"].types.pages[loaderRequest]
                    ? this.$store.state[ModulePrefix + "_post"].types.pages[loaderRequest]
                    : null;
            };
        }
        return computed;
    }
    else if (isLoaderRequestElement(loaderRequest)) {
        var contentType_1 = "type" in loaderRequest ? loaderRequest.type : "pages";
        var dataName = "dataName" in loaderRequest ? loaderRequest.dataName : loaderRequest.slug;
        if (dataName.trim() !== '') {
            if (loaderRequest.slug === '') {
                computed[dataName] = function () {
                    return this.$store.state[ModulePrefix + "_post"].types[contentType_1] &&
                        this.$store.state[ModulePrefix + "_post"].types[contentType_1]
                        ? this.$store.state[ModulePrefix + "_post"].types[contentType_1]
                        : null;
                };
            }
            else {
                computed[dataName] = function () {
                    return this.$store.state[ModulePrefix + "_post"].types[contentType_1] &&
                        this.$store.state[ModulePrefix + "_post"].types[contentType_1][ResolveRoute(loaderRequest.slug, this.$route)]
                        ? this.$store.state[ModulePrefix + "_post"].types[contentType_1][ResolveRoute(loaderRequest.slug, this.$route)]
                        : null;
                };
            }
        }
        return computed;
    }
    else if (Array.isArray(loaderRequest)) {
        for (var _i = 0, loaderRequest_1 = loaderRequest; _i < loaderRequest_1.length; _i++) {
            var request = loaderRequest_1[_i];
            computed = tslib_1.__assign({}, computed, buildComputed.call(this, request));
        }
    }
    else {
        throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
    }
    return computed;
};
export default buildComputed;
//# sourceMappingURL=Computed.js.map